package org.javacodegeeks.examples.v4;

import reactor.core.publisher.Flux;
import reactor.core.scheduler.Schedulers;

import java.util.function.Function;

public class GroupByHangExampleMain {

    public static void main(String[] args) {
        Flux.range(1, 1000)
            .groupBy(Function.identity())
            .flatMap(integerIntegerGroupedFlux -> {
                System.out.println("Got " + integerIntegerGroupedFlux.key());
                return integerIntegerGroupedFlux.subscribeOn(Schedulers.boundedElastic());
            }, 800)
            .subscribeOn(Schedulers.boundedElastic())
            .blockLast();
    }
}
